<?php
   /*
   Plugin Name: Featured Image Viewer
   Plugin URI: http://convexum.net/featured-image-viewer
   Description: A simple plugin to return the featured image for each blog post if set.
   Version: 0.1
   Author: Laurence Madill
   Author URI: http://convexum.net/about
   License: GPL2
   */

add_action( 'admin_menu', 'my_admin_menu' );

function my_admin_menu() {
	add_menu_page( 'Display status of featured images for each', 'Featured Image Viewer', 'manage_options', 'featured-image-viewer/featured-image-viewer.php', 'featured_image_view_list', 'dashicons-camera', 13  );
//  7 args:       Title tag,                  Name in menue,     restrict what groups see it,   menu slug,          function,                        icon,              order in list           )
}

if ( is_admin() ) {
register_activation_hook( __FILE__, array( 'featured-images', 'activate' ) );
register_deactivation_hook( __FILE__, array( 'featured-images', 'deactivate' ) );
}

function featured_image_view_list() {
  ?>
    <div class="wrap">
      <h2>Featured Image Viewer</h2>
      <p>For active posts only, this lists each post (most recent at the top)
        with its Featured Image and whether a "Continue Reading" marker has
        been set. Click the "Edit" link to go to edit the post in a new tab.
        Click the "View" link to go to view the post in a new tab. </p>
        <p>For further information on the plugin, please visit
          <a href="http://convexum.net/featured-image-viewer/" target="_blank">the plugin page</a>.</p>
    </div>
  <?php

global $wpdb;
$results = $wpdb->get_results(
"SELECT
p1.id as post_id,
p1.post_date,
p1.post_title as post_title,
p1.post_name as slug,
p1.post_date as created,
p1.post_modified as modified,
IFNULL(wm2.meta_value,'No Image') as imagepath,
case when wm2.meta_value is not null then 1 else 0 end as ImageIsSet,
case when p1.post_content like '%<!--more-->%' then 'Yes' else 'No' end as ContinueReadingLinkExists
FROM
wp_posts p1
LEFT JOIN
wp_postmeta wm1
ON (
  wm1.post_id = p1.id
  AND wm1.meta_value IS NOT NULL
  AND wm1.meta_key = '_thumbnail_id'
)
LEFT JOIN
wp_postmeta wm2
ON (
  wm1.meta_value = wm2.post_id
  AND wm2.meta_key = '_wp_attached_file'
  AND wm2.meta_value IS NOT NULL
)
WHERE
p1.post_status='publish'
AND p1.post_type='post'
ORDER BY
p1.post_date DESC

                      ");
echo '<table border="1" cellpadding="3" cellspacing="0">';
echo   '<th>Post ID</th>
        <th>Post Title</th>
        <!--<th>Post Slug</th>-->
        <th>Date Created</th>
        <th>Date Modified</th>
        <th>Featured Image:</th>
        <!--<th>Edit</th>-->
        <!--<th>View</th>-->
        <th>"Continue Reading" <br />link exists';
foreach ($results as $row)
    {
      echo
        '<tr>'.
          '<td>'.$row->post_id.'</td>'.
          '<td><strong>'.$row->post_title.'</strong><br />'.
                //'<em>Slug: '.$row->slug.'</em><br />'.
                '<a href="/'.$row->slug.'" target="_blank">View</a> | <a href="/wp-admin/post.php?post='.$row->post_id.'&action=edit" target="_blank">Edit</a>'.
            '</td>'.
          //'<td>'.$row->slug.'</td>'.
          '<td>'.$row->created.'</td>'.
          '<td>'.$row->modified.'</td>';
      if ($row->ImageIsSet == 1) {
        echo '<td><img src="/wp-content/uploads/'.$row->imagepath.'" width="200" /></td>';
      }
      else {
        echo '<td>Image not set</td>';
      }
      echo
          //'<td><a href="/wp-admin/post.php?post='.$row->post_id.'&action=edit" target="_blank">Edit</a></td>'.
          //'<td><a href="/'.$row->slug.'" target="_blank">View</a></td>'.
          '<td>'.$row->ContinueReadingLinkExists.'</td>'.
        '</tr>';
    }

}

?>
